---
title: DataTransferItemList.length
slug: Web/API/DataTransferItemList/length
tags:
  - API
  - DataTransferItemList
  - Draggged Items
  - Drop Items
  - HTML DOM
  - HTML Drag and Drop API
  - Item List
  - Property
  - Read-only
  - Reference
  - drag and drop
  - length
---
<p>The read-only <code><strong>length</strong></code> property of the {{domxref("DataTransferItemList")}} interface returns the number of items currently in the drag item list.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>length</em> = <em>DataTransferItemList</em>.length;
</pre>

<h3 id="Return_Value">Value</h3>

<p>The number of drag data items in the list, or 0 if the list is empty or disabled. The drag item list is considered to be disabled if the item list's {{domxref("DataTransfer")}} object is not associated with a drag data store.</p>

<h2 id="Example_Drag_and_Drop">Example</h2>

<p>This example shows the use of the <code>length</code> property.</p>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">function dragstart_handler(ev) {
  console.log("dragStart");
  // Add this element's id to the drag payload so the drop handler will
  // know which element to add to its tree
  var dataList = ev.dataTransfer.items;
  dataList.add(ev.target.id, "text/plain");
  // Add some other items to the drag payload
  dataList.add("&lt;p&gt;... paragraph ...&lt;/p&gt;", "text/html");
  dataList.add("http://www.example.org","text/uri-list");
}

function drop_handler(ev) {
  console.log("Drop");
  ev.preventDefault();
  var data = ev.dataTransfer.items;
  // Loop through the dropped items and log their data
  for (var i = 0; i &lt; data.length; i++) {
    if ((data[i].kind == 'string') &amp;&amp; (data[i].type.match('^text/plain'))) {
      // This item is the target node
      data[i].getAsString(function (s){
        ev.target.appendChild(document.getElementById(s));
      });
    } else if ((data[i].kind == 'string') &amp;&amp; (data[i].type.match('^text/html'))) {
      // Drag data item is HTML
      data[i].getAsString(function (s){
        console.log("... Drop: HTML = " + s);
      });
    } else if ((data[i].kind == 'string') &amp;&amp; (data[i].type.match('^text/uri-list'))) {
      // Drag data item is URI
      data[i].getAsString(function (s){
        console.log("... Drop: URI = " + s);
      });
    }
  }
}

function dragover_handler(ev) {
  console.log("dragOver");
  ev.preventDefault();
  // Set the dropEffect to move
  ev.dataTransfer.dropEffect = "move"
}

function dragend_handler(ev) {
  console.log("dragEnd");
  var dataList = ev.dataTransfer.items;
  // Clear any remaining drag data
  dataList.clear();
}

</pre>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;div&gt;
  &lt;p id="source" ondragstart="dragstart_handler(event);" ondragend="dragend_handler(event);" draggable="true"&gt;
     Select this element, drag it to the Drop Zone and then release the selection to move the element.&lt;/p&gt;
&lt;/div&gt;
&lt;div id="target" ondrop="drop_handler(event);" ondragover="dragover_handler(event);"&gt;Drop Zone&lt;/div&gt;
</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css">div {
  margin: 0em;
  padding: 2em;
}

#source {
  color: blue;
  border: 1px solid black;
}

#target {
  border: 1px solid black;
}
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example_Drag_and_Drop')}}</p>

<p>{{LiveSampleLink('Example_Drag_and_Drop', 'Drag and Drop demo link')}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'interaction.html#dom-datatransferitemlist-length','length')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', 'editing.html#dom-datatransferitemlist-length','length')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>Not included in W3C HTML5 {{Spec2('HTML5 W3C')}}</td>
  </tr>
  <tr>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DataTransferItemList.length")}}</p>

<div>{{APIRef("HTML Drag and Drop API")}}</div>
